#============================================================
# Calendar
#============================================================
package Calendar;
use Common;
@ISA = qw(Common);

#֥롼
#@EXPORT   = qw(erfc tan);
@EXPORT_OK = qw();

use strict;

my @WeekDayStrs = qw(Su Mo Tu We Th Fr Sa);

#============================================================
#󥹥ȥ饯ǥȥ饯
#============================================================
sub new
{
	my ($module) = @_;
	my $this = {};
	bless $this;
#	$this->SUPER::new(@_);
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#Сؿ
#============================================================
sub GetNowDate
{
	my ($this) = @_;
	
	my ($ss, $mm, $hh, $day, $month, $year) = localtime(time);
	$year += 1900;
	$month++;
	return ($year, $month, $day, $hh, $mm, $ss);
}

sub FillDate
{
	my ($this, $Year, $Month, $Day) = @_;

	my ($year, $month, $day, $hh, $mm, $ss) = $this->GetNowDate();
	$Year  = $year if($Year <= 0 or  $Year < 1900);
	$Month = $month if($Month <= 0 or $Month >= 13);
	$Day   = $day if($Day <= 0 or $Day >= 32);
	return ($Year, $Month, $Day);
}

sub CheckDate
{
	my ($this, $App, $Year, $Month, $Day) = @_;

	if($Year > 1900) {
		if(1 <= $Month and $Month <= 12) {
			my ($FirstDayOfMonday, $DaysInMonth) = $App->GetFirstWday($Year, $Month);
			if(1 <= $Day and $Day <= $DaysInMonth) {
				return 1;
			}
		}
	}
	return 0;
}

sub CorrectMonth
{
	my ($this, $App, $Year, $Month) = @_;

	if($Month <= 0) {
		$Month = 12 + $Month;
		$Year--;
	}
	elsif($Month >= 13) {
		$Month = $Month - 12;
		$Year++;
	}
	return ($Year, $Month);
}

sub CorrectDate
{
	my ($this, $App, $Year, $Month, $Day, $NonRecursive) = @_;

#$App->print("Maaaaaaaaaaaaaaaaaaaaaaaaaa: $Year/$Month/$Day => ");
	if($this->CheckDate($App, $Year, $Month, $Day)) {
#$App->print("-2: $Year/$Month/$Day\n");
		return ($Year, $Month, $Day) 
	}

	($Year, $Month) = $this->CorrectMonth($App, $Year, $Month);
	if($this->CheckDate($App, $Year, $Month, $Day)) {
#$App->print("-1: $Year/$Month/$Day\n");
		return ($Year, $Month, $Day) 
	}

	my ($FirstDayOfMonday, $DaysInMonth) = $App->GetFirstWday($Year, $Month);
#$App->print("Maaaaaaaaaaaaaaaaaaaaaaaaaa: $Year/$Month/$Day => $DaysInMonth<br>\n");
	if($Day <= 0) {
		($Year, $Month) = $this->CorrectMonth($App, $Year, $Month - 1);
		my ($fwday, $days) = $App->GetFirstWday($Year, $Month);
		$Day   = $days + $Day;

		if($this->CheckDate($App, $Year, $Month, $Day)) {
#$App->print("1: $Year/$Month/$Day\n");
			return ($Year, $Month, $Day);
		}
	}
	elsif($Day >= $DaysInMonth) {
#		($Year, $Month) = $this->CorrectMonth($App, $Year, $Month + 1);
		my ($fwday, $days) = $App->GetFirstWday($Year, $Month);
		$Day   = $Day - $days;
		($Year, $Month) = $this->CorrectMonth($App, $Year, $Month + 1);
		if($this->CheckDate($App, $Year, $Month, $Day)) {
#$App->print("2: $Year/$Month/$Day\n");
			return ($Year, $Month, $Day);
		}
	}

	($Year, $Month, $Day) = $this->CorrectDate($App, $Year, $Month, $Day, 0);
#	($Year, $Month, $Day) = $this->CorrectDate($App, $Year, $Month, $Day, 1) if(!$NonRecursive);

#$App->print("Final: $Year/$Month/$Day\n");
	return ($Year, $Month, $Day);
}

sub GetToDoPageString
{
	my ($this, $SApp, %arg) = @_;

	my $UseJavaScript = $arg{UseJavaScript};
	my $LoadJavaScript = $arg{LoadJavaScript};
	my $Year          = $arg{Year};
	my $Month         = $arg{Month};
	my $Day           = $arg{Day};
	my $DBConfig      = $arg{DBConfig};
	my $Apparatus     = $arg{Apparatus};
	my $EMail         = $arg{EMail};
	my $Password      = $arg{Password};
	my $ShowAll       = $arg{ShowAll};
	my $FontSize      = $arg{FontSize};
	my $ShowAll       = $arg{ShowAll};
	my $ViewMonthLink = $arg{ViewMonthLink};
	my $ViewDayLink   = $arg{ViewDayLink};
	my $FromDate      = $arg{FromDate};
	my $ToDate        = $arg{ToDate};
	my $CharCode      = $arg{CharCode};

	my $s = '';
	my ($DB, $DBConfigName, $DBMName, $DBServer, $DBUser, $DBPassword, $DBName, $UsersTableName, $ScheduleTableName, $MessageTableName)
			= $SApp->OpenDB($DBConfig);
	if(!defined $DB) {
		return "<H3>Error in Schedule.pm: Can not open Schedule DB</H3>";
	}

	my $LogonUserPrivilege = $SApp->GetPrivilege($DB, $EMail);
	my $LogonLevel         = $SApp->UserAuthorization($DB, $EMail, $Password, $Apparatus);
	if($LogonLevel <= 0) {
		$s .= "<br><b>Error in Schedule.pm: [$EMail:$LogonLevel] does not have right to show Schedule</b><br>\n";
		return $s;
	}

	my %Holiday;
	for(my $m = $Month - 1 ; $m <= $Month + 1 ; $m++) {
		my ($y2, $m2, $d2) = $this->CorrectDate($SApp, $Year, $m, $Day, 1);
		$SApp->SearchSchedule($DB, $EMail, "(Year=$y2 and Month=$m2 and Apparatus='Holiday')", 'Holiday', $ShowAll);
#		$SApp->SearchSchedule($DB, $EMail, "Year=$Year and Month=$Month and Apparatus='Holiday' and (DeleteTime is null or DeleteTime='' or DeleteTime='NULL')", "");
		my $nHit = $SApp->nHit();
#$s .= "Holiday: Start [$nHit]<br>\n";
		while(1) {
			my %Hit = $SApp->GetNextHit();
			last if(!defined $Hit{sn});

			$Holiday{"$Hit{Year}/$Hit{Month}/$Hit{Day}"} = $Hit{Comment};
#$s .= "Holiday: $Hit{Year}/$Hit{Month}/$Hit{Day} $Hit{Apparatus}<br>\n";
		}
	}

	$SApp->SearchSchedule($DB, $EMail, "(Year=$Year and Month=$Month)", $Apparatus, $ShowAll);
	my $SourceCharCode = '';
	while(1) {
		my %Hit = $DB->GetNextHit();
		last if(!defined $Hit{sn});

		if($SourceCharCode eq '' or $SourceCharCode eq 'ascii') {
			$SourceCharCode = Jcode::getcode($Hit{Comment} . $Hit{Secret});
		}
		else {
			last;
		}
	}
	$SourceCharCode = $CharCode if($SourceCharCode eq '');

	my %ToDo;
	$SApp->SearchSchedule($DB, $EMail, "(Year=$Year and Month=$Month)", $Apparatus, $ShowAll);
	while(1) {
		my %Hit = $DB->GetNextHit();
		last if(!defined $Hit{sn});
		my $line = "$Hit{Year}/$Hit{Month}/$Hit{Day}: $Hit{Comment}<br>\n";
if($SourceCharCode ne '' and $SourceCharCode ne 'ascii') {
	Jcode::convert(\$line, $CharCode, $SourceCharCode);
}
		$ToDo{"$Hit{Year}/$Hit{Month}/$Hit{Day}"} = "<a href=\"$ViewDayLink&EMail=$EMail&Password=$Password&App=$Apparatus&Year=$Hit{Year}&Month=$Hit{Month}&Day=$Hit{Day}&DBConfigName=$DBConfigName\" target=\"_blank\"><b>%s</b></a>"; ##$Hit{Comment};
	}

	$s .= "<table>\n";
	$s .= "<tr>\n";
	$s .= "  <td valign=\"top\">\n";
	$s .= $this->GetMonthHTMLString($SApp, 
		{
		Minimize        => 0,
		ShowHeadingLine => 1,
		FontSize        => $FontSize,
		Year            => $Year, 
		Month           => $Month, 
		Day             => $Day, 
		pHoliday        => \%Holiday, 
		pToDo           => \%ToDo,
		MonthLink => "$ViewMonthLink&EMail=$EMail&Password=$Password&App=$Apparatus&DBConfigName=$DBConfigName",
		}
		);

	if($UseJavaScript) {
		my $TodayString = Utils::BuildDateString(time(), undef, '{year}/{monthZero}/{dayZero}');

		my $s1 = <<EOT;

<link rel="stylesheet" href="/jscripts/jquery-ui/ui-lightness/jquery-ui-1.8.16.custom.css" type="text/css">
<script type="text/javascript" src="/jscripts/jquery/jquery-1.6.4.min.js"></script>
<script type="text/javascript" src="/jscripts/jquery-ui/jquery-ui-1.8.16.custom.min.js"></script>

EOT
		$s .= $s1 if($LoadJavaScript);

		$s1 = <<EOT;

<script language="JavaScript"><!--

\$(function() {
	\$("#date").datepicker({
		dateFormat: "yy/mm/dd",
		changeYear: true,
		changeMonth: true,
		prevText: '',
		nextText: '',
		currentText: '',
//		dayNamesMin: ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"],
//		monthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
		dayNamesMin: ["", "", "", "", "", "", ""],
		monthNames: ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"],
		monthNamesShort: ["1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12"],

		onSelect: function(d) {
//			alert(d + " is selected");
			sArray = d.split("/");

			base = '$ViewDayLink&EMail=$EMail&Password=$Password&App=$Apparatus&DBConfigName=$DBConfigName'
//			location.href = base + "&Year=" + sArray[0] + "&Month=" + sArray[1] + "&Day=" + sArray[2];
			window.open(base + "&Year=" + sArray[0] + "&Month=" + sArray[1] + "&Day=" + sArray[2]);
		}
	});
});

//--></script>

<input type="text" id="date" width="10" value="$TodayString"><br>

EOT
		$s .= $s1;
	}

	$s .= "  </td>\n";
	$s .= "  <td>\n";

	my %Today;
#$SourceCharCode = '';
	for(my $diff = $FromDate ; $diff <= $ToDate ; $diff++) {
		my ($year, $month, $day) = $this->CorrectDate($SApp, $Year, $Month, $Day + $diff);
		$SApp->SearchSchedule($DB, $EMail,
				"(Year=$year and Month=$month and Day=$day)",
				$Apparatus, $ShowAll);
		while(1) {
			my %Hit = $DB->GetNextHit();
			last if(!defined $Hit{sn});

#if($SourceCharCode eq '' or $SourceCharCode eq 'ascii') {
#	my $s = $Hit{Comment} . $Hit{Secret};
#	$SourceCharCode = Jcode::getcode($s);
#}
			my $wd = Utils::getDayOfWeekString($Hit{Year}, $Hit{Month}, $Hit{Day}, 3, 'jp', $CharCode);
#Jcode::convert(\$wd, $CharCode, $SourceCharCode);
			my $t = '';
			if($Hit{Starttime} >= 0) {
				$t .= " " . $SApp->IntToTimeStr($Hit{Starttime}) . "-";
			}
			if($Hit{Endtime} >= 0) {
				$t .= $SApp->IntToTimeStr($Hit{Endtime});
			}
			$Hit{Comment} =~ s/[\r\n].*$//s;
			$Hit{Comment} = 'no message' if($Hit{Comment} eq '');
			my $line = '';
if($SourceCharCode ne '' and $SourceCharCode ne 'ascii') {
	Jcode::convert(\$Hit{Comment}, $CharCode, $SourceCharCode);
}
			if($EMail eq $Hit{EMail}) {
				$line = "<b>$Hit{Year}/$Hit{Month}/$Hit{Day}($wd)$t:</b> <a href=\"$ViewDayLink&EMail=$EMail&Password=$Password&App=$Apparatus&sn=$Hit{sn}&Year=$Hit{Year}&Month=$Hit{Month}&Day=$Hit{Day}&DBConfigName=$DBConfigName\" target=\"_blank\">$Hit{Comment}</a><br>\n";
#Jcode::convert(\$line, $CharCode);
			}
			else {
				$line = "<b>$Hit{Year}/$Hit{Month}/$Hit{Day}($wd)$t:</b> <a href=\"$ViewDayLink&EMail=$EMail&Password=$Password&App=$Apparatus&Year=$Hit{Year}&Month=$Hit{Month}&Day=$Hit{Day}&DBConfigName=$DBConfigName\" target=\"_blank\">$Hit{Comment}</a><br>\n";
#Jcode::convert(\$line, $CharCode);
			}
			$s .= $line;
			$ToDo{"$Hit{Year}/$Hit{Month}/$Hit{Day}"} = "<b>%s</b>";
		}
	}

	$s .= "  </td>\n";
	$s .= "</tr>\n";
	$s .= "</table>\n";

	return $s;
}

sub GetMonthHTMLString
{
	my ($this, $App, $pParams) = @_;
	my $Year      = $pParams->{Year};
	my $Month     = $pParams->{Month};
	my $Day       = $pParams->{Day};
	my $pHoliday  = $pParams->{pHoliday};
	my $pToDo     = $pParams->{pToDo};
	my $fontsize  = $pParams->{FontSize};
	$fontsize = 2 if(!defined $fontsize);
	my $MonthLink = $pParams->{MonthLink};
	my $pwdaystrs = $pParams->{pWeekDayText};
	my @wday = ($pwdaystrs)? @$pwdaystrs : @WeekDayStrs;
	my ($bold0, $bold1) = ($pParams->{Minimize})? ("", "") : ("<b>", "</b>");

	my $content = '';

	($Year, $Month, $Day) = $this->FillDate($Year, $Month, $Day);

	my $DateKey = "$Year/$Month/Day";
	my $today = $Day;

#	my ($prev_year, $prev_month, $prev_day) = $this->CorrectDate($App, $Year, $Month-1, $Day);
#	my ($next_year, $next_month, $next_day) = $this->CorrectDate($App, $Year, $Month+1, $Day);
	my ($prev_year, $prev_month, $prev_day) = $this->CorrectDate($App, $Year, $Month-1, 1);
	my ($next_year, $next_month, $next_day) = $this->CorrectDate($App, $Year, $Month+1, 1);

	$content .= "<table border  cellspacing=\"0\" cellpadding=\"0\">\n";
	if($pParams->{ShowHeadingLine}) {
		$content .= "<tr align=center valign=center>\n";
		my ($link0, $link1) = ('', '');
		if($MonthLink ne '') {
			$link0 = "<a href=\"$MonthLink&Year=$prev_year&Month=$prev_month\" target=\"_blank\">";
			$link1 = "</a>";
		}

		if($pParams->{Minimize}) {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">&lt;&lt;</font>$link1</td>\n";
		}
		elsif($prev_year != $Year) {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$prev_year/$prev_month</font>$link1</td>\n";
		}
		else {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$prev_month</font>$link1</td>\n";
		}

		if($MonthLink ne '') {
			$link0 = "<a href=\"$MonthLink&Year=$Year&Month=$Month\" target=\"_blank\">";
			$link1 = "</a>";
		}
		$content .= "  <td align=center valign=center colspan=\"3\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$Year/$Month$bold1</font>$link1</td>\n";

		if($MonthLink ne '') {
			$link0 = "<a href=\"$MonthLink&Year=$next_year&Month=$next_month\" target=\"_blank\">";
			$link1 = "</a>";
		}
		if($pParams->{Minimize}) {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">&gt;&gt;</font>$link1</td>\n";
		}
		elsif($next_year != $Year) {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$next_year/$next_month</font>$link1</td>\n";
		}
		else {
			$content .= "  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
						  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$next_month</font>$link1</td>\n";
		}
		$content .= "<tr/>\n";
	}
	$content .= "
<tr align=center valign=center>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFF00\" size=\"$fontsize\">$bold0$wday[0]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$wday[1]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$wday[2]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$wday[3]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$wday[4]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$wday[5]$bold1</font></td>
  <td align=center valign=center bgcolor=\"#0000FF\"><font color=\"#00FFFF\" size=\"$fontsize\">$bold0$wday[6]$bold1</font></td>
</tr>
";

	my ($FirstDayOfMonday, $DaysInMonth) = $App->GetFirstWday($Year, $Month);
	my($color, $bgcolor, $desc);
	my $d     = 1;
	my $daym1 = 0;
	for (my $i = 0; ; $i++) {
		my $s = '';
		last if ($i % 7 == 0 && $i > $DaysInMonth+7);

		$content .= "<tr align=\"center\">\n" if ($i % 7 == 0);
		my $day = $i - $FirstDayOfMonday;
		$daym1 = $day + 1;
		my $diffYear = $Year;
		my $diffMon  = 0;
		my $diffDay  = 0;
		if ($i < $FirstDayOfMonday) {			# 
			($diffYear, $diffMon, $diffDay) = $this->CorrectDate($App, $diffYear, $diffMon-1, $diffDay);
			$diffMon = $Month - 1;
			my ($fwday2, $days2) = $App->GetFirstWday($diffYear, $diffMon);
			$diffDay = $days2 - ($FirstDayOfMonday-$i) + 1;
		}
		elsif ($i >= ($FirstDayOfMonday + $DaysInMonth)) {	# 
			last if ($i % 7 == 0);
			$diffMon = $Month + 1;
			if($diffMon > 12) {
				$diffYear = $Year + 1;
				$diffMon = 1;
			}
			my ($fwday2, $days2) = $App->GetFirstWday($diffYear, $diffMon);
			$diffDay = $i - ($FirstDayOfMonday+$DaysInMonth) + 1;
		}
		if($diffDay <= 0) {
			$diffYear = $Year;
			$diffMon  = $Month;
			$diffDay  = $daym1;
		}
		($diffYear, $diffMon, $diffDay) = $this->CorrectDate($App, $diffYear, $diffMon, $diffDay);

		my $IsHoliday = 0;
		my $diffDateKey = "$diffYear/$diffMon/$diffDay";
		if($pHoliday->{$diffDateKey} ne '') {
			$IsHoliday = 1;
		}
#$s .= "IsHoliday=$IsHoliday<br>\n";
		my $DateFormat = '%d';
		if($pToDo->{$diffDateKey} ne '') {
			$DateFormat = $pToDo->{$diffDateKey};
		}
		if($d == $today) {		# 
			$color   = "#000000";
			$bgcolor = "#FF9900";
			$day     = $d++;
		}
		elsif($IsHoliday) {			# 
			$day     = $d++;
			$color   = "#FFFFFF";
			$bgcolor = "#FF0000";
		}
		elsif($i < $FirstDayOfMonday) {	# 
			$color   = "#000000";
			$bgcolor = "#C0C0C0";
			$day     = -1;
		}
		elsif($i >= ($FirstDayOfMonday + $DaysInMonth)) {	# 
			$color   = "#000000";
			$bgcolor = "#C0C0C0";
			$day     = -1;
		}
		elsif($i % 7 == 0) {		# 
			$color   = "#000000";
			$bgcolor ="#FFA6A6";
			$day     = $d++;
		}
		elsif($i % 7 == 6) {		# 
			$color   = "#000000";
			$bgcolor = "#A8A8FF";
			$day     = $d++;
		}
		else {						# ʿ
			$color   = "#000000";
			$bgcolor = "#E0E0F0";
			$day     = $d++;
		}

#		if($IsHoliday) {			# 
#			$color   = "#FFFFFF";
#			$bgcolor = "#FF0000";
#		}

		$content .= "<td align=\"center\" bgcolor=\"$bgcolor\">";
		if($diffDay > 0) {
			$day = "$diffMon/$diffDay";
		}
		else {
			$day = "--";
		}
		my $daystr = sprintf($DateFormat, $diffDay);
		$content .= "<font size=\"$fontsize\">";
		$content .= "$daystr";
		$content .= "</font>";
		$content .= "</td>\n";
		$content .= "</tr>\n" if ($i % 7 == 6);
	}
	$content .= "</table>\n";
	
	return $content;
}

sub ShowMonth
{
	my ($this, $App, $pParams) = @_;
	my $s = $this->GetMonthHTMLString($App, $pParams);
	$App->PrintRawHTML($s);
	return $s;

	my $Year      = $pParams->{Year};
	my $Month     = $pParams->{Month};
	my $Day       = $pParams->{Day};
	my $pHoliday  = $pParams->{pHoliday};
	my $pToDo     = $pParams->{pToDo};
	my $fontsize  = $pParams->{FontSize};
	$fontsize = 2 if(!defined $fontsize);
	my $MonthLink = $pParams->{MonthLink};
	my $pwdaystrs = $pParams->{pWeekDayText};
	my @wday = ($pwdaystrs)? @$pwdaystrs : @WeekDayStrs;
	my ($bold0, $bold1) = ($pParams->{Minimize})? ("", "") : ("<b>", "</b>");

	$App->print("");
	($Year, $Month, $Day) = $this->FillDate($Year, $Month, $Day);

	my $DateKey = "$Year/$Month/Day";
	my $today = $Day;

	my ($prev_year, $prev_month, $prev_day) = $this->CorrectDate($App, $Year, $Month-1, $Day);
	my ($next_year, $next_month, $next_day) = $this->CorrectDate($App, $Year, $Month+1, $Day);

	$App->PrintRawHTML("<table border  cellspacing=\"0\" cellpadding=\"0\">\n");
	if($pParams->{ShowHeadingLine}) {
		$App->PrintRawHTML("<tr align=center valign=center>\n");
		my ($link0, $link1) = ('', '');
		if($MonthLink ne '') {
			$link0 = "<a href=\"$MonthLink&Year=$prev_year&Month=$prev_month\" target=\"_blank\">";
			$link1 = "</a>";
		}
		else {
			($link0, $link1) = ('', '');
		}
		if($pParams->{Minimize}) {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">&lt;&lt;</font>$link1</td>\n");
		}
		elsif($prev_year != $Year) {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$prev_year/$prev_month</font>$link1</td>\n");
		}
		else {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."$link0<font color=\"#FFFFFF\" size=\"$fontsize\">$prev_month</font>$link1</td>\n");
		}

		$App->PrintRawHTML("  <td align=center valign=center colspan=\"3\" bgcolor=\"#0000FF\">"
						  ."<font color=\"#FFFFFF\" size=\"$fontsize\">$bold0$Year/$Month$bold1</font></td>\n");

		if($pParams->{Minimize}) {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."<font color=\"#FFFFFF\" size=\"$fontsize\">&gt;&gt;</font></td>\n");
		}
		elsif($next_year != $Year) {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."<font color=\"#FFFFFF\" size=\"$fontsize\">$next_year/$next_month</font></td>\n");
		}
		else {
			$App->PrintRawHTML("  <td align=center valign=center colspan=\"2\" bgcolor=\"#0000FF\">"
							  ."<font color=\"#FFFFFF\" size=\"$fontsize\">$next_month</font></td>\n");
		}
		$App->PrintRawHTML("<tr/>\n");
	}
	print <<EOT;
<tr align=center valign=center>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFF00" size="$fontsize">$bold0$wday[0]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFFFF" size="$fontsize">$bold0$wday[1]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFFFF" size="$fontsize">$bold0$wday[2]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFFFF" size="$fontsize">$bold0$wday[3]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFFFF" size="$fontsize">$bold0$wday[4]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#FFFFFF" size="$fontsize">$bold0$wday[5]$bold1</font></td>
  <td align=center valign=center bgcolor="#0000FF"><font color="#00FFFF" size="$fontsize">$bold0$wday[6]$bold1</font></td>
</tr>
EOT

	my ($FirstDayOfMonday, $DaysInMonth) = $App->GetFirstWday($Year, $Month);
	my($color, $bgcolor, $desc);
	my $d     = 1;
	my $daym1 = 0;
	for (my $i = 0; ; $i++) {
		my $s = '';
		last if ($i % 7 == 0 && $i > $DaysInMonth+7);

		$App->PrintRawHTML("<tr align=\"center\">\n") if ($i % 7 == 0);
#		$App->PrintRawHTML("<tr align=\"center\" valign=\"center\">\n") if ($i % 7 == 0);
		my $day = $i - $FirstDayOfMonday;
		$daym1 = $day + 1;
		my $diffYear = $Year;
		my $diffMon  = 0;
		my $diffDay  = 0;
		if ($i < $FirstDayOfMonday) {			# 
			($diffYear, $diffMon, $diffDay) = $this->CorrectDate($App, $diffYear, $diffMon-1, $diffDay);
			$diffMon = $Month - 1;
			my ($fwday2, $days2) = $App->GetFirstWday($diffYear, $diffMon);
			$diffDay = $days2 - ($FirstDayOfMonday-$i) + 1;
		}
		elsif ($i >= ($FirstDayOfMonday + $DaysInMonth)) {	# 
			last if ($i % 7 == 0);
			$diffMon = $Month + 1;
			if($diffMon > 12) {
				$diffYear = $Year + 1;
				$diffMon = 1;
			}
			my ($fwday2, $days2) = $App->GetFirstWday($diffYear, $diffMon);
			$diffDay = $i - ($FirstDayOfMonday+$DaysInMonth) + 1;
		}
		if($diffDay <= 0) {
			$diffYear = $Year;
			$diffMon  = $Month;
			$diffDay  = $daym1;
		}
		($diffYear, $diffMon, $diffDay) = $this->CorrectDate($App, $diffYear, $diffMon, $diffDay);

		my $IsHoliday = 0;
		my $diffDateKey = "$diffYear/$diffMon/$diffDay";
		if($pHoliday->{$diffDateKey} ne '') {
			$IsHoliday = 1;
		}
		my $DateFormat = '%d';
		if($pToDo->{$diffDateKey} ne '') {
			$DateFormat = $pToDo->{$diffDateKey};
		}
#$App->print("d: $diffYear/$diffMon/$diffDay [$IsHoliday]<br>\n");
		if($i < $FirstDayOfMonday) {	# 
			$color   = "#000000";
			$bgcolor = "#C0C0C0";
			$day     = -1;
		}
		elsif($i >= ($FirstDayOfMonday + $DaysInMonth)) {	# 
			$color   = "#000000";
			$bgcolor = "#C0C0C0";
			$day     = -1;
		}
		elsif($d == $today) {		# 
			$color   = "#000000";
			$bgcolor = "#FF9900";
			$day     = $d++;
		}
		elsif($IsHoliday) {			# 
			$day     = $d++;
			$color   = "#FFFFFF";
			$bgcolor = "#FF0000";
		}
		elsif($i % 7 == 0) {		# 
			$color   = "#000000";
			$bgcolor ="#FFA6A6";
			$day     = $d++;
		}
		elsif($i % 7 == 6) {		# 
			$color   = "#000000";
			$bgcolor = "#A8A8FF";
			$day     = $d++;
		}
		else {						# ʿ
			$color   = "#000000";
			$bgcolor = "#E0E0F0";
			$day     = $d++;
		}

#		if($IsHoliday) {			# 
#			$color   = "#FFFFFF";
#			$bgcolor = "#FF0000";
#		}

		$App->PrintRawHTML("<td align=\"center\" bgcolor=\"$bgcolor\">");
#		$App->PrintRawHTML("<td align=\"center\" valign=\"center\" bgcolor=\"$bgcolor\">\n");
		if($diffDay > 0) {
			$day = "$diffMon/$diffDay";
		}
		else {
			$day = "--";
		}
		my $daystr = sprintf($DateFormat, $diffDay);
		$App->PrintRawHTML("<font size=\"$fontsize\">");
		$App->PrintRawHTML("$daystr");
		$App->PrintRawHTML("</font>");
		$App->PrintRawHTML("</td>\n");
		$App->PrintRawHTML("</tr>\n") if ($i % 7 == 6);
	}
	$App->PrintRawHTML("</table>\n");
}

1;