#!/usr/bin/perl

use lib 'd:/Programs/Perl/lib';
use lib 'd:/Programs/Perl/lib2.0';
use lib '.';

use strict;

use MyApplication2;
use Device::Device;

$SIG{INT} = \&ctrl_c_handler;
BEGIN {
#	$| = 1;
	open (STDERR, ">&STDOUT");
}

#===============================================
# ֌Wϐ
#===============================================
#f[^t@C̖O
my $DataFileName = "CPM1.csv";

#OWait
my $WaitBefore = 1.0;
my $WaitForMeasurement = 30.0;

#Keithley6517A̐ݒd
my $V = 3.0;

#Keuthley6517A[`FbN
my $ZeroCheck = 'on';

#ς
my $nAverage = 10;

#Cornerstone130̑g͈̔
my $WStart = 200;
my $WEnd   = 800;
my $WStep  = 2.0;



#O
my $Who = 'Tsukamoto';
my $Today = Utils::BuildDateString(time());



#===============================================
# ApplicationIuWFNg쐬
#===============================================
my $App = new MyApplication2;
$App->SetOutputMode("auto");
my $ProgramPath = $App->SpeculateProgramPath($0, "");
my $IniFile = $App->OpenIniFile($ProgramPath, 1);
#$App->AddIniFileVariable("\\Preferences\\DeviceName", "DeviceName", "Keithley2000");
#$App->AddIniFileVariable("\\Preferences\\Port",       "Port",       "GPIB17");
$App->ReadSetting();



#===============================================
# DeviceIuWFNg쐬
#===============================================
my $K6517A         = OpenDevice("Keithley6517A",  "GPIB27");
#my $K2000          = OpenDevice("Keithley2000",   "GPIB17");
my $Cornerstone130 = OpenDevice("Cornerstone130", "COM1");
my $Laserstar3APLS = OpenDevice("Laserstar3APLS", "COM4");

#Keithley6517Ȁ
$K6517A->Initialize();
$K6517A->SetDCCurrentMode($ZeroCheck);
$K6517A->SetAutoRangeForCurrent("on");


#Laserstar 3AP-LSݒ
$Laserstar3APLS->SetRange("auto");
$Laserstar3APLS->SetPowerMode();



#===============================================
# Jn
#===============================================
my $nWStep = int( ($WEnd - $WStart) / $WStep + 1.000001 );

Utils::sleep($WaitBefore);

$K6517A->SetSourceVoltage($V);
$K6517A->SetVSourceOutput("on");
$Cornerstone130->GoWave($WStart);
$Cornerstone130->Shutter("0");      #Vb^[J


#܊iq̔gݒ肳ꂽAlԂENTERL[Ď̍Ƃɐi
print "\nPress ENTER if ready>";
<>;



#t@C
if(-w $DataFileName) { print "Can write to [$DataFileName]\n"; }
my $out = new JFile;
if(!$out->Open($DataFileName, "w")) {
	print "Error: Can not write to [$DataFileName]\n";
	exit;
}


#ExcelpɃf[^o
$out->print("W,I,L,**********Measured by $Who, $Today,\n");
for(my $i = 0 ; $i < $nWStep ; $i++) {
	my $W = $WStart + $WStep * $i;

	$Cornerstone130->GoWave($W);
	Utils::sleep($WaitForMeasurement);
	print("Waiting $WaitForMeasurement s...\n");

	my $I = $K6517A->MeasureAveraged($nAverage);
	my $L = $Laserstar3APLS->Measure();
	print("W=$W  I=$I  L=$L\n");
	$out->print("$W,$I,$L\n");
}

$out->Close();


#Cornerstone130Vb^[
$Cornerstone130->Shutter("1");


exit;



#============================================================
#@ʊ֐
#============================================================
sub ctrl_c_handler{
	$App->print("CTRL+C pressed\n");
	$App->print("Input 'yes' if terminate this program.\n>>");
	my $line = <>;
	if($line =~ /^\s*yes\s*$/i) {
	   exit;
	}
	return;
}


sub OpenDevice
{
	my ($DeviceName, $Port) = @_;
	Utils::DelSpace($DeviceName);
	Utils::DelSpace($Port);

#RS232C̐ݒ
my $ConfFile        = '';
my $COMPort         = 'COM1';
my $UseModule       = 0;
my $BaudRate        = 9600;
my $Parity          = 'none';
my $DataBits        = 8;
my $StopBits        = 1;
my $HandShake       = 'none';
my $WriteBufferSize = 1024 * 20;
my $ReadBufferSize  = 1024 * 4;
my $ReadInterval    = 800;
my $ReadCharTime    = 400;
my $ErrorMessage    = 1;
my $UserMessage     = 1;


#GPIB̐ݒ
my $GPIBInterface   = "ni";
my $GPIBTimeOut     = GPIB->T1s;
my $GPIBEOT         = 1;
my $GPIBEOS         = 0;

	my $dev = new Device(
			-Port               => $Port,
			-ModuleName         => $DeviceName,
			-DeviceName         => $DeviceName,
			-GPIBInterface      => $GPIBInterface,
			-GPIBTimeOut        => $GPIBTimeOut,
			-GPIBEOT            => $GPIBEOT,
			-GPIBEOS            => $GPIBEOS,
			-COMConfName        => $ConfFile,
			-COMBaudRate        => $BaudRate,
			-COMParity          => $Parity,
			-COMDataBits        => $DataBits,
			-COMStopBits        => $StopBits,
			-COMHandShake       => $HandShake,
			-COMWriteBufferSize => $WriteBufferSize,
			-COMReadBufferSize  => $ReadBufferSize,
			-COMReadInterval    => $ReadInterval,
			-COMReadCharTime    => $ReadCharTime,
			-COMErrorMessage    => $ErrorMessage,
			-COMUserMessage     => $UserMessage,
			-PrintError         => 1,
			);
	if(!defined $dev) {
		$App->print("Device can not be opened. [$DeviceName: $Port]\n");
		exit;
	}

	my $Id = $dev->GetId();
	$App->print("$DeviceName: [$dev->{ModuleName}:$dev->{Port}] (Object: $dev)\n");
	$App->print("Id: $Id\n");

	return $dev;
}



