#============================================================
# SteppingmotorD92
#============================================================
package SteppingmotorD92;
use Device::DeviceObject;
@ISA = qw(DeviceObject);

#JTu[`
@EXPORT = qw();

use strict;
use Deps;

my $DefaultWaitForGratingChange = 10;
my $UseRead = 0;

#============================================================
#@RXgN^AfXgN^
#============================================================
BEGIN { }

sub new
{
	my ($module, @args) = @_;
	my $this = {};
	bless $this;
#	$this->Initialize();
	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->Finish();
}

#============================================================
#@ϐ擾֐
#============================================================
sub GetFunctions { return "|Wavelength|Position|"; }

#============================================================
#@ʊ֐
#============================================================

sub Initialize
{
	my ($this) = @_;
}


sub Finish
{
	my ($this) = @_;
}

sub GetId
{
	my ($this) = @_;
	return 'Fixed: Stepping motor controller model D92';
}


sub SetPPS
#オ葬xݒ
{
	my ($this, $speed) = @_;
	$this->print("XL${speed}UG\r\n");
	return $this->read();
}

sub SetPresentPosition
{
	my ($this, $Pos) = @_;
	if(!defined $Pos) {
		$this->print("XS\r\n");
	}
	else {
		$this->print("XS$Pos\r\n");
	}
}

sub GetPosition
#|WVv
{
	my ($this, $axis) = @_;
	$this->print('?X' . "\r\n");
	return $this->read();
}


sub SetX
#݈ʒu(|WV)ݒG
{
	my ($this, $positionX) = @_;
	my $PresentPos = $this->GetPosition();
#	my $PresentPos = 0;
	my $Move = $positionX - $PresentPos;
	$this->MoveRelativeX($Move);
}

sub MoveRelativeX
{
	my ($this, $Move) = @_;
	if($Move > 0) {
		$this->print("XP${Move}UG\r\n");
	}
	elsif($Move < 0) {
		$Move = -$Move;
		$this->print("XP${Move}DG\r\n");
	}
}

sub GetAxis
#Wv
{
	my ($this, $axis) = @_;
	$this->print('&' . "\n");
	return $this->read();
}

sub QuickStop
#}~
{
	my ($this) = @_;
	$this->print('E' . "\n");
}

sub SlowStop
#~
{
	my ($this) = @_;
	$this->print('H' . "\n");
}

sub SetSpeed
#쓮xݒ
{
	my ($this, $speed) = @_;
	$this->print("XF${speed}UG\n");
}

sub SetAcceleration
#[gݒ
{
	my ($this, $acceleration) = @_;
	$this->print("XR${acceleration}UG\n");
	return $this->read();
}

1;