#!/usr/bin/perl

use lib 'd:/Programs/Perl/lib';

BEGIN {
#use lib 'd:/Programs/Perl/lib';
#use lib '/home/tkamiya/bin/lib';
my $BaseDir = $ENV{'PerlDir'};
$BaseDir = $ENV{'TkPerlDir'} unless(defined $BaseDir);
#print "BaseDir: $BaseDir\n";
@INC = ("$BaseDir/lib", "$BaseDir/VNL", @INC);
}

use strict;

use OpticsC;
use Optics;

my $e1inf = 0.6385;
my $e2inf = 0.0;
my $A     = 252.1;
my $Eg    =  8.5; # eV, Tauc gap
my $En0   = 12.0; # eV, Lorentz oscillation energy
my $C     =  8.542; # eV, Damping factor

my $opt = new Optics;

for(my $E = 0.4 ; $E < 5.0 ; $E += 0.2) {
	my $ret1 = TaucLorentz($E, $e1inf, $e2inf, $A, $Eg, $En0, $C);
	my ($ret2, $ret3) = $opt->TaucLorentz($E, $e1inf, $e2inf, $A, $Eg, $En0, $C);
	printf("E=%6.4g eV: C: %12.6g  Perl(%12.6g, %12.6g)\n", $E, $ret1, $ret2, $ret3);
}

