#========================================================
# TkPlotApp2
#========================================================
package TkPlotApp2;
use MyTk::MyTkApplication;
@ISA = qw(MyTkApplication);

use strict;

use TkPlotWindow2;

#============================================================
#　変数等取得関数
#============================================================

#============================================================
#　コンストラクタ、デストラクタ
#============================================================
sub new
{
	my $class = shift;

	my $self = MyTkApplication->new(@_);
	my $this = bless $self, $class;

	return $this;
}

sub DESTROY
{
	my $this = shift;
	$this->SUPER::DESTROY(@_);
}

#============================================================
#　初期化ファイルの設定
#============================================================
sub ConfigureIniFileVariables
{
	my ($App) = @_;
	my $Style = $App->Args()->GetGetArg("style");
	$Style = "General" unless($Style);

	$App->AddIniFileVariable("\\Preferences\\EditorPath",       "EditorPath",         "notepad.exe");
	$App->AddIniFileVariable("\\Preferences\\StartAppPath",     "StartAppPath",       "");
	$App->AddIniFileVariable("\\Preferences\\PSViewer1Path",    "PSViewer1Path",      "");
	$App->AddIniFileVariable("\\Preferences\\PSViewer1Name",    "PSViewer1Name",      "");
	$App->AddIniFileVariable("\\Preferences\\PSViewer2Path",    "PSViewer2Path",      "");
	$App->AddIniFileVariable("\\Preferences\\PSViewer2Name",    "PSViewer2Name",      "");
	$App->AddIniFileVariable("\\Preferences\\Debug",            "Debug",              0);
	$App->AddIniFileVariable("\\FileContentText\\Font",         "FileContentFont",    "times,10.5,normal");
	$App->AddIniFileVariable("\\LeftFrame\\Width",              "LeftFrameWidth",     10);

	$App->AddIniFileVariable("\\$Style\\SetWindowPos",               "SetWindowPos",           1);
	$App->AddIniFileVariable("\\$Style\\WorkDir",                    "WorkDir",                '');
	$App->AddIniFileVariable("\\$Style\\geometry",                   "geometry",               '');
	$App->AddIniFileVariable("\\$Style\\FileMask",                   "FileMask",               ".*");
	$App->AddIniFileVariable("\\$Style\\GraphFrame_GraphFont",       "GraphFrameFont",         "times,14,normal");
	$App->AddIniFileVariable("\\$Style\\GraphFrame_GraphSymbolFont", "GraphFrameSymbolFont",   "symbol,14,normal");
#	$App->AddIniFileVariable("\\$Style\\GraphFrame_Position",        "GraphFramePosition",     "r0.20,0.80,0.80,0.10");
	$App->AddIniFileVariable("\\$Style\\GraphFrame0_Position",       "GraphFrame0Position",    "r0.20,0.60,0.80,0.10");
	$App->AddIniFileVariable("\\$Style\\GraphFrame1_Position",       "GraphFrame1Position",    "r0.20,0.80,0.80,0.60");
	$App->AddIniFileVariable("\\$Style\\GraphFrame2_Position",       "GraphFrame2Position",    "r0.20,0.80,0.80,0.80");
#	$App->AddIniFileVariable("\\$Style\\GraphFrameDOS0_Position",    "GraphFrameDOS0Position", "r0.20,0.80,0.80,0.45");
#	$App->AddIniFileVariable("\\$Style\\GraphFrameDOS1_Position",    "GraphFrameDOS1Position", "r0.20,0.45,0.80,0.10");
	$App->AddIniFileVariable("\\$Style\\ShowMousePosition",          "ShowMousePosition",      "1");

#	$App->AddIniFileVariable("\\$Style\\vgeometry",           "vgeometry",           '');
#	$App->AddIniFileVariable("\\GraphFrame0\\Position",       "GraphFrame0Position", "100,450,450,50");
#	$App->AddIniFileVariable("\\GraphFrame1\\Position",       "GraphFrame1Position", "100,550,450,450");
#	$App->AddIniFileVariable("\\GraphFrame2\\Position",       "GraphFrame2Position", "100,650,450,550");

	$App->ReadSetting();

#print "Style: $Style\n";
#print "GraphFrame0Position: $App->{EditorPath}\n";
#exit;

	$App->{Debug} = 0;
	$App->{LeftFrameWidth} = 50 unless($App->{LeftFrameWidth});
}

1;
