import sys
import tkinter as tk
from tkinter import ttk
import xml.etree.ElementTree as ET


filename = sys.argv[1]

def load_xml_file(filename):
    tree = ET.parse(filename)
    root = tree.getroot()
    return root

def populate_treeview(treeview, parent, element):
    # 要素のテキストを取得
    text = element.text if element.text else ""

    # ツリービューに要素を挿入
    item_id = treeview.insert(parent, 'end', text=text)

    # 子要素を再帰的に処理
    for child in element:
        populate_treeview(treeview, item_id, child)

def main():
    # Tkinterウィンドウの作成
    root = tk.Tk()
    root.title("XMLファイルの表示")

    # ツリービューの作成
    treeview = ttk.Treeview(root)
    treeview.pack(fill = tk.BOTH, expand = True)

    # XMLファイルの読み込み
    xml_data = load_xml_file(filename)

    # ツリービューにデータを挿入
    populate_treeview(treeview, '', xml_data)

    # Tkinterメインループの開始
    root.mainloop()

if __name__ == "__main__":
    main()