
use strict;
BEGIN {
use lib 'd:/Programs/Perl/lib';
#use lib '/home/tkamiya/bin/lib';
my $BaseDir = $ENV{'TkPerlDir'};
#print "\nBaseDir: $BaseDir\n";
@INC = ("$BaseDir/lib", "$BaseDir/VNL", "c:/Programs/Perl/lib", "d:/Programs/Perl/lib", @INC);
}

use Crystal::Crystal;
use Crystal::CIF;
use Sci::ChemicalReaction;

my $a = 4.341;
my ($na, $nb, $nc) = (2, 2, 2);
my $CIFFile = "FeO-TypeII.cif";

my $crystal = new Crystal;
$crystal->SetLatticeParameters($na*$a, $nb*$a, $nc*$a, 90.0, 90.0, 90.0);
$crystal->SetSpaceGroup("P 1");

my @MPos = ( [0.0, 0.0, 0.0], [0.5, 0.5, 0.0], [0.5, 0.0, 0.5], [0.0, 0.5, 0.5] );
my @OPos = ( [0.5, 0.0, 0.0], [0.0, 0.5, 0.0], [0.0, 0.0, 0.5], [0.5, 0.5, 0.5] );
my %iAtom;
for(my $ia = 0 ; $ia < $na ; $ia++) {
	for(my $ib = 0 ; $ib < $nb ; $ib++) {
		for(my $ic = 0 ; $ic < $nc ; $ic++) {
			for(my $i = 0 ; $i < @MPos ; $i++) {
				my ($x0, $y0, $z0) = @{$MPos[$i]};
				my $x = ($x0+$ia) / $na;
				my $y = ($y0+$ib) / $nb;
				my $z = ($z0+$ic) / $nc;
				my $check = int(($x+$y+$z)*2 + 0.001) % 2;
				my $atom = ( $check == 0 )? 'Fe' : 'V';
				$iAtom{$atom}++;
				$crystal->AddAtomSite("$atom$iAtom{$atom}", $atom, $x, $y, $z);
			}

			for(my $i = 0 ; $i < @OPos ; $i++) {
				my ($x0, $y0, $z0) = @{$OPos[$i]};
				my $x = ($x0+$ia) / $na;
				my $y = ($y0+$ib) / $nb;
				my $z = ($z0+$ic) / $nc;
				my $atom = 'O';
				$iAtom{$atom}++;
				$crystal->AddAtomSite("$atom$iAtom{$atom}", $atom, $x, $y, $z);
			}
		}
	}
}
$crystal->ExpandCoordinates();

CIF->new()->CreateCIFFileFromCCrystal($crystal, $CIFFile);
